;                        ._____ _______ __________.
;                        |                      (_:
;                        |   RIPIITTERI logiikka  |
;                        |_  v1.1i (2002 OH3HRK)  |
;                        :_)________/)____________|
;                        "
;                          - oh3hrk(at)sral.fi -

;  DTMF:
;  *      - aukaisee ripiitterin kuten 1750hz
;  *0     - aukaisee ja antaa toistimen kutsun, paikan ja lokaattorin
;  *9     - sulkee ripiitterin
;  #9     - sulkee ripiitterin
;  A897   - Huoltotila (kuulet SET)
;         - * pois Huoltotilasta
;         - 0 sulje 5min ajaksi
;         - 1 sulje 10min ajaksi
;         - 2 sulje 20min ajaksi
;         - 3 sulje 30min ajaksi
;         - 4 sulje 40min ajaksi
;         - 5 sulje 50min ajaksi
;         - 6 sulje 60min ajaksi
;         - 7 sulje 120min ajaksi
;         - 8 sulje 240min ajaksi
;         - 9 sulje kokonaan (virrat pit ottaa pois ja laittaa takas)
;         - # kerro Tilastot, antaa
;             - OPN ???? ???? = QSO ???? ???? = K
;               eli monta kertaa toistin avattu ja monta kertaa
;               pidetty qso, eli vh. 5-vuoroiset.. numerot annetaan 2 kertaa
;               numerot on muuten heksana, eli ne pit muuttaa sen jlkeen..
;               lopuksi * palaa alkuun taa # nollaa ne ja palaa alkuun
;         - A Ulostulo RB6 pinni eli IC:n pinni 12 pois (GND)
;         - B Ulostulo RB6 pinni eli IC:n pinni 12 plle (+5V)
;
;  Versiot:
;    v1.0     - Ensimminen
;    v1.1     - Korjattu EEPROM kirjoitusbitti bugi
;    v1.1i    - Salpatieto invertoitu

;--[ alku juttuja ]--:

        title   "REPEATER_LOGIC_11"
        list    P=16F84;f=inhx8m
        include "P16F84.INC"

;--[ ohjelmointilaitteelle asetukset ]--:
;--[ xt, watchdog, power up timer ]--:
        __config        0x3FFD

        

;--[ eeprom asetukset ]--:
        org     0x2100

        ; Alku cw teksti
        data    'O','H','3','R','A','C','-','-'

        ; id cw teksti (keskell)
        data    'O','H','3','R','A','C','-','-'

        ; lopetus cw teksti
        data    'O','H','3','R','A','C','-','-'

        ; sulkeutumis merkit (2 kpl)   18h 19h 
        data    'C','L'

        ; monta Sekuntia pit puhua ett sulkeutuu 0x3C = 60
        data    0x3C ;--- 1Ah

        ; miten usein ID 1bh? 0A = 10 min
        data    0x0A

        ; cw taajuus .. pienempi on matalampi --- 1Ch
        data 0xEF

        ; cw nopeus .. pienempi on nopeampi!!
        data    0x11 ;--- 1Dh

        ; monta Sekuntia saa olla puhumatta? 1Eh
        data 0x08

        ; monta Sekuntia saa olla puhumatta lhettimen pois menon jlkeen
        ; ennen kuin sulkeutuu oikeasti? 1Fh
        data 0x07 

        ; info teksti
        data    'D','E',' ','O','H','3','R','A','C',' '
        data    'L','A','H','T','I',' ','K','P','2','0','T','X'
        data    '-','-','-','-','-','-'

        ; laskurit, kerrat avattu ja kerrat qsottu 16bit
        data    0x00,0x00,0x00,0x00

;--[ muisti alueita omille jutuille ]--:
	cblock	0x0C
        IntrCount               
        Safe_W                  
        Safe_S
        Counter                 ; laskee esim. kauan puhuttu sekunteja
        Counter_L               ; sekunteja 0-60
        Counter_H               ; minuutteja .. laskee esim. millon pit antaa ID
        CWSpeed
        CWChar
        CloseTime
        Temp
        Temp2
        Temp3
        Vuorot
        Counter2
        IDTime
        CWPitch
        ToneCount
        SpTimeOut
        SpTimeOutL
        TilastoTmp
       	endc

IO_Mute         equ     0       ; Mykistys
IO_TX           equ     1       ; Lhetin
IO_SND          equ     2       ; ni
IO_Led          equ     3       ; Vihre LED
IO_DTMF         equ     4       ; DTMF
IO_Sql          equ     5       ; Salpa
IO_Pin12        equ     6       ; Pinni 12
IO_Tone         equ     7       ; Piippa


;--[ koodin Alku ]--:
        org     0              
        goto    Alku            ; mennn pois keskeytys koodin alta

;--[ keskeytys rutiini ]--:
        org     4               ; keskeytys alkaa kohdasta 4
        movwf   Safe_W          ; Ota W rekisteri talteen Safe_W rekisteriin
        swapf   STATUS, W       ; Swappaa statuksen nibblet ja laita W:hen.
        movwf   Safe_S          ; Tallenna W Safe_S rekisteriin

        clrwdt
        incf    IntrCount, F    ; Joka keskeytys nostaa IntrCount yhdell.
                                ; Onko IntrCount 0xF0?
        movfw   IntrCount       ; Laita IntrCount W rekisteriin
        xorlw   0xF0            ; W XOR F0. Jos W=F0 niin ZERO flagi plle
        btfsc   STATUS, Z       ; Skip Clear. Ohita jos ZERO flagi pois.
        call    Sekunti         ; Sekunti on mennyt, kutsu Sekunti!

        movfw   IntrCount
        xorlw   0x78
        btfsc   STATUS, Z
        bsf     PORTA, IO_Led   ; Ledi paalle

        ; Jos keskeytys sotkisi STATUS- ja W-Rekisterit niin tapahtuisi
        ; kauheita, joten ne palautetaan keskeytyksen jlkeen....

        swapf   Safe_S, W       ; Hae vanha status Safe_S rekkarista. Swap.
        movwf   STATUS          ; Laita status rakaisin W rekkarista.
        swapf   Safe_W, F       ; Swappaa Safe_W nibblet.
        swapf   Safe_W, W       ; Swappaa Safe_W nibblet TAAS ja laita W:hen.
        bcf     INTCON, 2       ; intcon rekisterin interrupt flag pois.
        retfie                  ; Palaa keskeytyksest

;--[ kun Sekunti on mennyt nosta laskuria ]--:
;--[ tai no tarpeeksi lhell Sekuntia... ]--:
Sekunti:
        bcf     PORTA, IO_Led   ; Ledi pois
        clrf    IntrCount       ; IntrCount nollataan
        incf    Counter, F
        incf    Counter2, F
        incf    Counter_L, F

        movfw   Counter_L
        xorlw   0x3C
        btfss   STATUS, Z
        return
        clrf    Counter_L
        incf    Counter_H, F    ; Jos alin meni yli 60 nosta ylint
        return

;--[ CW merkit  ]--:
;--[ ensin tyhj ykksill, kunnes tulee ensimminen nolla ]--:
;--[ 1 = piste ja 0 = viiva ]--:
CWMerkki
                addwf   PCL, F

                retlw           b'11000000'     ; 0
                retlw           b'11010000'     ; 1
                retlw           b'11011000'     ; 2
                retlw           b'11011100'     ; 3
                retlw           b'11011110'     ; 4
                retlw           b'11011111'     ; 5
                retlw           b'11001111'     ; 6
                retlw           b'11000111'     ; 7
                retlw           b'11000011'     ; 8
                retlw           b'11000001'     ; 9

                retlw           b'11111010'     ; 10 - A .-
                retlw           b'11100111'     ; 11 - B -...
                retlw           b'11100101'     ; 12 - C -.-.
                retlw           b'11110011'     ; 13 - D -..
                retlw           b'11111101'     ; 14 - E .
                retlw           b'11101101'     ; 15 - F ..-.
                retlw           b'11111111'     ; RFU
                retlw           b'11111111'     ; RFU
                retlw           b'11111111'     ; RFU
                retlw           b'11111111'     ; RFU

                retlw           b'11111111'     ; RFU
                retlw           b'11111111'     ; RFU
                retlw           b'11111111'     ; RFU
                retlw           b'11111111'     ; RFU
                retlw           b'11111111'     ; RFU
                retlw           b'11111111'     ; RFU
                retlw           b'11010010'     ; 26 - 
                retlw           b'11101010'     ; 27 - 
                retlw           b'11100001'     ; 28 - 
                retlw           b'11001010'     ; 29 - (KA) -.-.-

                retlw           b'11001001'     ; 30 - (KN) -.--.
                retlw           b'10111010'     ; 31 - (SK) ...-.-
                retlw           b'00000000'     ; 32 - VLILYNTI
                retlw           b'11011001'     ; 33 - !
                retlw           b'10101101'     ; 34 - "
                retlw           b'11111111'     ;(35 - #)
                retlw           b'11111111'     ;(36 - $)
                retlw           b'11111111'     ;(37 - %)
                retlw           b'11111111'     ;(38 - &)
                retlw           b'10100001'     ; 39 - '

                retlw           b'11001001'     ; 40 - (
                retlw           b'10010010'     ; 41 - )
                retlw           b'11111111'     ; 42 - *
                retlw           b'11010101'     ; 43 - + .-.-.
                retlw           b'10001100'     ; 44 - ,
                retlw           b'11111111'     ; 45 - - (TYHJ MERKKI)
                retlw           b'10101010'     ; 46 - .
                retlw           b'11001101'     ; 47 - /

                retlw           b'11000000'     ; 48 - 0
                retlw           b'11010000'     ; 49 - 1
                retlw           b'11011000'     ; 50 - 2
                retlw           b'11011100'     ; 51 - 3
                retlw           b'11011110'     ; 52 - 4
                retlw           b'11011111'     ; 53 - 5
                retlw           b'11001111'     ; 54 - 6
                retlw           b'11000111'     ; 55 - 7
                retlw           b'11000011'     ; 56 - 8
                retlw           b'11000001'     ; 57 - 9

                retlw           b'10000111'     ; 58 - :
                retlw           b'11111111'     ;(59 - ;)
                retlw           b'11111111'     ;(60 - <)
                retlw           b'11001110'     ; 61 - =
                retlw           b'11111111'     ;(62 - >)
                retlw           b'10110011'     ; 63 - ?
                retlw           b'11111111'     ;(64 - @)

                retlw           b'11111010'     ; 65 - A .-
                retlw           b'11100111'     ; 66 - B -...
                retlw           b'11100101'     ; 67 - C -.-.
                retlw           b'11110011'     ; 68 - D -..
                retlw           b'11111101'     ; 69 - E .
                retlw           b'11101101'     ; 70 - F ..-.
                retlw           b'11110001'     ; 71 - G --.
                retlw           b'11101111'     ; 72 - H ....
                retlw           b'11111011'     ; 73 - I ..
                retlw           b'11101000'     ; 74 - J .---
                retlw           b'11110010'     ; 75 - K -.-
                retlw           b'11101011'     ; 76 - L .-..
                retlw           b'11111000'     ; 77 - M --
                retlw           b'11111001'     ; 78 - N -.
                retlw           b'11110000'     ; 79 - O ---
                retlw           b'11101001'     ; 80 - P .--.
                retlw           b'11100010'     ; 81 - Q --.-
                retlw           b'11110101'     ; 82 - R .-.
                retlw           b'11110111'     ; 83 - S ...
                retlw           b'11111100'     ; 84 - T -
                retlw           b'11110110'     ; 85 - U ..-
                retlw           b'11101110'     ; 86 - V ...-
                retlw           b'11110100'     ; 87 - W .--
                retlw           b'11100110'     ; 88 - X -..-
                retlw           b'11100100'     ; 89 - Y -.--
                retlw           b'11100011'     ; 90 - Z --..

;--[ muuttaa DTMF numerot dekooderilta jrkevmpn muotoon ]--:
;--[ pinnit on muutenkin nurin pin ]--:

DTMFTabl
                addwf   PCL, F

                retlw   0x0D
                retlw   0x08
                retlw   0x04 
                retlw   0x0F ; #
                retlw   0x02 

                retlw   0x00
                retlw   0x06
                retlw   0x0B
                retlw   0x01
                retlw   0x09

                retlw   0x05
                retlw   0x0A
                retlw   0x03
                retlw   0x0E ; *
                retlw   0x07

                retlw   0x0C

;--[ sulku minuuttien lista ]--:
SulkuTabl
                addwf   PCL, F
                retlw   0x05            ;5min
                retlw   0x0A            ;10min
                retlw   0x14            ;20
                retlw   0x1E            ;30
                retlw   0x28            ;40
                retlw   0x32            ;50
                retlw   0x3C            ;60
                retlw   0x78            ;120
                retlw   0xF0            ;240

                retlw   0x01            ;rfu
                retlw   0x01
                retlw   0x01
                retlw   0x01
                retlw   0x01
                retlw   0x01

;---------------------------------------------------------------------------:

;--[ ohjelman Alku ]--:
Alku:
        bcf     INTCON, 2       ; Nollaa TMR0 Interrupt Flagi
        bsf     INTCON, 7       ; Global Interrupts plle
        bsf     INTCON, 5       ; TMR0 Interrupt plle
        clrf    TMR0            ; Nollaa TMR0
        clrwdt

        movlw   b'11000011'     ; Eli nyt keskeytys joka 16. ksky.
        bsf     STATUS, RP0     ; bank1
        movwf   OPTION_REG^80H
        bcf     STATUS, RP0     ; bank0
        clrf    TMR0            ; Nollaa TMR0 taas.

        bsf     STATUS, RP0     ; bank1
        clrf    TRISA^80H       ; PORTA outputeiksi
        movlw   b'10111111'     ; PORTB inputeiksi paitsi yksi
        movwf   TRISB^80H
        bcf     STATUS, RP0     ; bank0

        bcf     PORTA, IO_TX    ; lhetin pois plt
        bsf     PORTA, IO_Mute  ; mykistys pois
        bsf     PORTB, IO_Pin12 ; RB6 plle

        movlw   0x1A
        call    LueEEPROM      ; hae EEPROM:mista vuoron pituusaika
        movwf   CloseTime       

        movlw   0x1B
        call    LueEEPROM
        movwf   IDTime

        movlw   0x1C
        call    LueEEPROM
        movwf   CWPitch

        movlw   0x1D
        call    LueEEPROM      ; hae EEPROM:mista CWSpeed
        movwf   CWSpeed

        movlw   0x1E
        call    LueEEPROM
        movwf   SpTimeOut

        movlw   0x1F
        call    LueEEPROM
        movwf   SpTimeOutL

;--[ luuppaa loputtomasti ]--:
MainLoop:
        bcf     PORTA, IO_TX    ; lhetin pois plt
        btfss   PORTB, IO_Sql   ; odota ett salpa aukeaa (RB5)
        goto    MainLoop

;--[ salpa aukesi ]--:
SalpaLoop:
        btfss   PORTB, IO_Tone  ; Piippaa painettu?? (RB7)
        goto    Piippa

        btfsc   PORTB, IO_DTMF  ; DTMF ni kuultu?
        goto    OnkoDTMFAani

        btfss   PORTB, IO_Sql   ; jos salpa on kiinni, palaa Alkuun
        goto    MainLoop        ; jos salpa on yh auki niin luuppaa..
        goto    SalpaLoop

OnkoDTMFAani
        movfw   PORTB
OdotaLoppua
        btfsc   PORTB, IO_DTMF  ; odota ett ni loppuu
        goto    OdotaLoppua

        andlw   0x0F
        call    DTMFTabl
        movwf   Temp3

        xorlw   0x0E            ; thti on mun systeemiss 0x0E!
        btfsc   STATUS, Z         
        goto    Piippa2         ; DTMF * siis tunnistettu, avaa toistin

        goto    SalpaLoop

DTMFIDAvaus:
        movfw   PORTB
        andlw   0x0F
        call    DTMFTabl

        xorlw   0x00            ; nolla?
        btfss   STATUS, Z
        goto    Piippa2

AnnaInfo:
        btfsc   PORTB, IO_Sql   ; odota ett salpa menee kiinni
        goto    AnnaInfo

        bcf     PORTA, IO_Mute  ; Mykistys plle
        bsf     PORTA, IO_TX    ; lhetin plle!

        call    PSekTauko       ; puolen sekunnin tauko

;--[ lhet info ]--:           ; antaa toistimen infot
        movlw   0x20
        movwf   Temp3
        call    PSekTauko
SendInf
        bcf     STATUS, RP0
        movfw   Temp3
        call    LueEEPROM
        call    CW

        incf    Temp3, F
        movfw   Temp3

        xorlw   0x3B
        btfss   STATUS, Z
        goto    SendInf

        goto    ToistinAuki2

;--[ Piippa tunnistettu, odota ett loppuu ]-:
Piippa:
        clrf    ToneCount       ; nollaa ToneCount laskuri
Piippac:
        clrw                    ; taukoa
        call    KeepPause 
        clrw                    ; taukoa
        call    KeepPause 

        incf    ToneCount, F    ; nosta laskuria
        btfsc   PORTB, IO_Tone  ; jos Piippa loppuu -
        goto    MainLoop        ; mene Alkuun

        movfw   ToneCount       ; jos Piippa on kestanyt tarpeeksi
        xorlw   0xA0   ;<--aika ; pitkaan, odota etta salpa menee
        btfsc   STATUS, Z       ; kiinni ja avaa toistin!
        goto    Piippa2
        goto    Piippac

Piippa2:
        btfsc   PORTB, IO_DTMF  ; DTMF kuultu?
        goto    DTMFIDAvaus     ; tarkista onko se nolla?
                                ; jos on anna infoa

        btfsc   PORTB, IO_Sql   ; odota ett salpa viel menee kiinni ;C
        goto    Piippa2
        goto    ToistinAuki     ; avaa toistin

;--[ TOISTIN ON AVATTU ]--:
ToistinAuki:
        bcf     PORTA, IO_Mute   ; Mykistys plle

        bsf     PORTA, IO_TX     ; lhetin plle!
        call    PSekTauko        ; puolen sekunnin tauko

;--[ lhet ID1 ]--:             ; antaa toistimen kutsun
        clrf    Temp3
SendID
        bcf     STATUS, RP0
        movfw   Temp3
        call    LueEEPROM
        call    CW

        incf    Temp3, F
        movfw   Temp3

        xorlw   0x08
        btfss   STATUS, Z
        goto    SendID

ToistinAuki2:

        movlw   0x3D
        call    LueEEPROM
        incf    EEDATA, F
        call    KirjoitaEEPROM

        movfw   EEDATA
        xorlw   0x00
        btfss   STATUS, Z
        goto    ToistinAuki3 

        movlw   0x3C
        call    LueEEPROM
        incf    EEDATA, F
        call    KirjoitaEEPROM

ToistinAuki3:

        call    PSekTauko       ; puolen sekunnin tauko
        call    Bongo           ; ja nimerkki

        clrf    Vuorot          ; nollaa vuorolaskuri
        clrf    IntrCount       ; nollaa IntrCount
        clrf    Counter         ; nollaa laskuri
        clrf    Counter_L       ; nollaa iso laskuri
        clrf    Counter_H

;--[ odottaa ett joku sanoo avauksen jlkeen jotain ]--:
;--[ jos kukaan ei sano mitn ? sekunnissa niin toistin menee kiinni ]--:

PLoop:
        btfsc   PORTB, IO_Sql
        goto    PLoopI          ; joku sanoi jotain

        movfw   Counter
        xorwf   SpTimeOut, W
        btfsc   STATUS, Z
        goto    MainLoop        ; turhaan avattu
        goto    PLoop

PLoopI:
        clrf    IntrCount       ; nollaa IntrCount
        clrf    Counter         ; nollaa laskuri

;--[ hpin luuppi ]--:
PuhuukoJoku:
        btfsc   PORTB, IO_Sql   ; puhuuko joku jotain?
        goto    JokuPuhuu

        movfw   Counter
        xorwf   SpTimeOut, W
        btfsc   STATUS, Z       ; jos kukaan ei puhu ? Sekuntiin niin ala
        goto    QSOLopetettu    ; valmistella toistimen sulkemista
        goto    PuhuukoJoku

;--[ joku aloitti puhumaan ]--;
JokuPuhuu:
        incf    Vuorot, F       ; nosta vuorojen lukumr
        movfw   Vuorot
        xorlw   0x10            ; yli 0x10?
        btfsc   STATUS, Z         
        decf    Vuorot, F

        bsf     PORTA, IO_TX    ; lhetin plle jos se ei ole
        clrf    IntrCount       ; nollaa IntrCount
        clrf    Counter2        ; nollaa laskuri

JokuPuhuuL1:
        bsf     PORTA, IO_Mute   ; Mykistys pois
        movfw   CloseTime
        xorwf   Counter2, W     ; puhuttu liian pitkn?
        btfsc   STATUS, Z
        goto    Ympari          ; (CL!)

        btfsc   PORTB, IO_DTMF  ; kuuluuko puheen aikana DTMF?
        goto    DTMFPainettu

        btfsc   PORTB, IO_Sql   ; vielk puhutaan?
        goto    JokuPuhuuL1     ; jos niin, jatka luuppia.

JokuPuhuuL2:                    ; salpa sulkeutui.. odota viel 0.5s jos se
        movlw   0x78            ; palaisi takaisin?
        movwf   IntrCount       ; IntrCount puoleen
        clrf    Counter         ; nollaa laskuri
JokuPuhuuL3:
        btfss   PORTB, IO_Sql   ; palasiko salpa takaisin
        goto    JokuPuhuuL4

        goto    JokuPuhuuL1     ; jatka puheenvuoroa

JokuPuhuuL4:
        movfw   Counter
        xorlw   0x01
        btfss   STATUS, Z
        goto    JokuPuhuuL3     ; odottele

;--[ puheenvuoro loppui ]---;        

        movfw   IDTime          ; onko IDTime suurempi kuin Counter_H?
        subwf   Counter_H, W
        btfss   STATUS, C
        goto    VuoroLoppui

        bcf     PORTA, IO_Mute   ; Mykistys plle

;--[ lhet ID2 ]--:             ; antaa toistimen kutsun
        movlw   0x08
        movwf   Temp3
SendID2
        bcf     STATUS, RP0
        movfw   Temp3
        call    LueEEPROM
        call    CW

        incf    Temp3, F
        movfw   Temp3

        xorlw   0x10
        btfss   STATUS, Z
        goto    SendID2

        call    PSekTauko        ; puolen sekunnin tauko
        clrf    Counter_L        ; nolla ID laskurit,
        clrf    Counter_H        ; koska ID on juuri annettu!

VuoroLoppui

        call    Bongo           ; ni
        goto    PLoopI          ; palaa Alkuun

WaitForDTMF
        btfss   PORTB, IO_Sql   ; salpa?
        goto    VuoroLoppui
        btfss   PORTB, IO_DTMF  ; odota ett ni alkaa
        goto    WaitForDTMF

        movfw   PORTB           ; PORTB W rekisteriin
        andlw   0x0F            ; otetaan vain 4 ekaa bitti kyttn
        call    DTMFTabl        ; haetaan ne DTMF tablesta W rekisteriin
WaitForEnd
        btfsc   PORTB, IO_DTMF  ; odota ett ni loppuu
        goto    WaitForEnd
        return                

DTMFPainettu
        movfw   PORTB
        andlw   0x0F
        call    DTMFTabl
        movwf   Temp3

        xorlw   0x0F            ; ruutu painettu?
        btfsc   STATUS, Z         
        goto    DTMFKomento

        movfw   Temp3
        xorlw   0x0E            ; thti painettu?
        btfsc   STATUS, Z         
        goto    DTMFKomento

        movfw   Temp3
        xorlw   0x0A            ; A painettu?
        btfsc   STATUS, Z         
        goto    Setuppi
        goto    JokuPuhuuL1

;--[ painettu ruutu (#) .. odota ett ruutu loppuu ja odota seuraavaa ]--:
;--[ ksky ]--: (tai * kay myos!! viime hetken muutos)
DTMFKomento:
        btfsc   PORTB, IO_DTMF  ; odota ett ni loppuu
        goto    DTMFKomento
DTMFKom1:

        btfss   PORTB, IO_Sql   ; salpa?
        goto    VuoroLoppui

        btfss   PORTB, IO_DTMF  ; odota ett ni alkaa
        goto    DTMFKom1

        movfw   PORTB
        andlw   0x0F
        call    DTMFTabl

        movwf   Temp3
        xorlw   0x09            ; painettu ysi? toistin menee kiinni
        btfsc   STATUS, Z
        goto    DTMFSulku

        ;--- tilaa muille # tai * alkuisille komennoille

        goto    JokuPuhuuL1
     
Setuppi:
        btfsc   PORTB, IO_DTMF  ; odota ett ni loppuu
        goto    Setuppi

        bcf     PORTA, IO_Mute   ; Mykistys plle ettei koodia kuulla

        ; !!!!! KOODI 897 !!!!!
        call    WaitForDTMF
        xorlw   0x08            ;<-------- 8
        btfss   STATUS, Z
        goto    JokuPuhuuL1

        call    WaitForDTMF
        xorlw   0x09            ;<-------- 9
        btfss   STATUS, Z
        goto    JokuPuhuuL1

        call    WaitForDTMF
        xorlw   0x07            ;<-------- 7
        btfss   STATUS, Z
        goto    JokuPuhuuL1

SetL1   btfsc   PORTB, IO_Sql   ; odota ett salpa menee kiinni
        goto    SetL1
        bcf     PORTA, IO_Mute   ; Mykistys plle ettei koodia kuulla

        call    PSekTauko
        movlw   'S'
        call    CW
        movlw   'E'
        call    CW
        movlw   'T'
        call    CW
        call    PSekTauko
        call    Bongo           

        clrf    Counter

HuoltoTila

        movfw   Counter
        xorlw   0x0A            ; 0a = 10 sek
        btfsc   STATUS, Z
        goto    JokuPuhuuL1
        
        btfss   PORTB, IO_DTMF  ; odota ett ni alkaa
        goto    HuoltoTila

        movfw   PORTB
        andlw   0x0F
        call    DTMFTabl

Huolto2:
        btfsc   PORTB, IO_DTMF  ; odota ett ni loppuu
        goto    Huolto2
Huol1   btfsc   PORTB, IO_Sql   ; odota ett salpa menee kiinni
        goto    Huol1

        movwf   Temp3
        xorlw   0x0E            ; thti, palaa Alkuun
        btfsc   STATUS, Z
        goto    JokuPuhuuL1

        movfw   Temp3
        xorlw   0x0F            ; ruutu? mene Tilasto juttuun
        btfsc   STATUS, Z
        goto    Tilasto

        movfw   Temp3
        xorlw   0x0A            ; RB6 pois
        btfsc   STATUS, Z
        goto    RB6_Off

        movfw   Temp3
        xorlw   0x0B            ; RB6 plle
        btfsc   STATUS, Z
        goto    RB6_On

        movfw   Temp3
        xorlw   0x09            ; sulje kokonaan
        btfsc   STATUS, Z
        goto    SuljeLopullisesti

        bcf     PORTA, IO_Mute  ; Mykistys plle
        movfw   Temp3

        call    PSekTauko
        movfw   Temp3
        call    CW              ; numero ja pern R
        call    PSekTauko
        movlw   'R'
        call    CW
        call    PSekTauko
        bsf     PORTA, IO_Mute  ; Mykistys pois

        bcf     PORTA, IO_TX

        call    SulkuTabl
        movwf   Temp3

        clrf    Counter_L
        clrf    Counter_H

OdotaAika
        movfw   IntrCount       ; jos laite suljettu
        xorlw   0x10            ; vilkuta erilailla ett tiet
        btfsc   STATUS, Z       ; mik on toimimattomuuden syy, jos
        bsf     PORTA, IO_Led   ; ilkivaltaisesti suljettu

        movfw   Temp3          ; onko IDTime sama kuin Counter_H?
        xorwf   Counter_H, W
        btfss   STATUS, Z
        goto    OdotaAika

        bcf     PORTA, IO_Mute  ; Mykistys plle

        bsf     PORTA, IO_TX
        call    PSekTauko
        movlw   'Q'
        call    CW
        movlw   'R'
        call    CW
        movlw   'V'
        call    CW
        call    PSekTauko
        bcf     PORTA, IO_TX

        bsf     PORTA, IO_Mute   ; Mykistys pois

        goto    MainLoop
      
RB6_On:
        bsf     PORTB, IO_Pin12
        bcf     PORTA, IO_Mute   ; Mykistys plle
        call    PSekTauko
        movlw   'O'
        call    CW
        movlw   'N'
        call    CW
        call    PSekTauko
        bsf     PORTA, IO_Mute   ; Mykistys pois
        goto    SetL1

RB6_Off:
        bcf     PORTB, IO_Pin12
        bcf     PORTA, IO_Mute   ; Mykistys plle
        call    PSekTauko
        movlw   'O'
        call    CW
        movlw   'F'
        call    CW
        movlw   'F'
        call    CW
        call    PSekTauko
        bsf     PORTA, IO_Mute   ; Mykistys pois
        goto    SetL1


SuljeLopullisesti:
        bcf     PORTA, IO_Mute   ; Mykistys plle
        call    PSekTauko
        movlw   'Q'
        call    CW
        movlw   'R'
        call    CW
        movlw   'T'
        call    CW
        call    PSekTauko
        bsf     PORTA, IO_Mute  ; Mykistys pois
EndLess
        movfw   IntrCount       ; jos laite suljettu
        xorlw   0x10            ; vilkuta erilailla ett tiet
        btfsc   STATUS, Z       ; mik on toimimattomuuden syy, jos
        bsf     PORTA, IO_Led   ; ilkivaltaisesti suljettu
                               
        bcf     PORTA, IO_TX
        goto    EndLess

DTMFSulku:
        btfsc   PORTB, IO_Sql   ; odota ett salpa menee kiinni
        goto    DTMFSulku

        bcf     PORTA, IO_Mute  ; Mykistys plle
        call    PSekTauko
        movlw   'C'
        call    CW
        movlw   'L'
        call    CW
        call    PSekTauko
        bsf     PORTA, IO_Mute  ; Mykistys pois

        goto    MainLoop

Tilasto:
        bcf     PORTA, IO_Mute  ; Mykistys plle
        movlw   0x1A
        movwf   CWSpeed

        movlw   'O'
        call    CW
        movlw   'P'  ; 3c3d3e3f
        call    CW
        movlw   'N' 
        call    CW
        movlw   ' '
        call    CW

        clrf    ToneCount
Tilasto1:
        ; anna 3C+3D numero 2 kertaa
        movlw   0x3C
        call    LueEEPROM
        movwf   TilastoTmp
        call    SendHi
        movfw   TilastoTmp
        call    SendLo

        movlw   0x3D
        call    LueEEPROM
        movwf   TilastoTmp
        call    SendHi
        movfw   TilastoTmp
        call    SendLo

        movlw   ' '
        call    CW

        incf    ToneCount, F
        movfw   ToneCount
        xorlw   0x02
        btfss   STATUS, Z
        goto    Tilasto1

        movlw   ' '
        call    CW
        movlw   '='
        call    CW
        movlw   ' '
        movlw   'Q'
        call    CW
        movlw   'S'
        call    CW
        movlw   'O'
        call    CW
        movlw   ' '
        call    CW

        clrf    ToneCount
Tilasto2:
        ; anna 3E+3F numero 2 kertaa
        movlw   0x3E
        call    LueEEPROM
        movwf   TilastoTmp
        call    SendHi
        movfw   TilastoTmp
        call    SendLo
        movlw   0x3F
        call    LueEEPROM
        movwf   TilastoTmp
        call    SendHi
        movfw   TilastoTmp
        call    SendLo
        movlw   ' '
        call    CW

        incf    ToneCount, F
        movfw   ToneCount
        xorlw   0x02
        btfss   STATUS, Z
        goto    Tilasto2

        movlw   ' '
        call    CW
        movlw   'K'
        call    CW

        bsf     PORTA, IO_Mute  ; Mykistys pois

        movlw   0x1D
        call    LueEEPROM      ; hae EEPROM:mista CWSpeed
        movwf   CWSpeed

        clrf    Counter
        clrf    IntrCount
TilastoL

        movfw   Counter
        xorlw   0x0A            ; 0a = 10 sek
        btfsc   STATUS, Z
        goto    SetL1
        
        btfss   PORTB, IO_DTMF  ; odota ett ni alkaa
        goto    TilastoL

        movfw   PORTB
        andlw   0x0F
        call    DTMFTabl

Tilasto3:
        btfsc   PORTB, IO_DTMF  ; odota ett ni loppuu
        goto    Tilasto3
Tilasto4:
        btfsc   PORTB, IO_Sql   ; odota ett salpa menee kiinni
        goto    Tilasto4

        movwf   Temp3
        xorlw   0x0E            ; thti, palaa Alkuun
        btfsc   STATUS, Z
        goto    SetL1

        movfw   Temp3
        xorlw   0x0F            ; ruutu? Alkuun
        btfss   STATUS, Z
        goto    SetL1

        movlw   0x3C            ; nollaa laskurit
        movwf   EEADR
        clrf    EEDATA
        movwf   EEADR
        call    KirjoitaEEPROM

        movlw   0x3D
        movwf   EEADR
        clrf    EEDATA
        call    KirjoitaEEPROM

        movlw   0x3E
        movwf   EEADR
        clrf    EEDATA
        call    KirjoitaEEPROM

        movlw   0x3F
        movwf   EEADR
        clrf    EEDATA
        call    KirjoitaEEPROM

        bcf     PORTA, IO_Mute  ; Mykistys plle
        call    PSekTauko
        movlw   'R'             ; rookeri
        call    CW
        call    PSekTauko
        bsf     PORTA, IO_Mute  ; Mykistys pois

        goto    SetL1
      
SendHi:
        movwf   Temp3
        rrf     Temp3, F
        rrf     Temp3, F
        rrf     Temp3, F
        rrf     Temp3, W
        andlw   0x0F
        call    CW
        return

SendLo
        andlw   0x0F
        call    CW
        return


;--[ toistin sulkeutuu mutta on viel ? sek aikaa sanoa jotain jolloin ]--:
;--[ toistin aukeaa viel jos jollain on asiaa ]--:
QSOLopetettu:
        bcf     PORTA, IO_TX    ; lhetin pois
        clrf    IntrCount
        clrf    Counter
QSOLop1:
        btfsc   PORTB, IO_Sql   ; aukeaako salpa viel
        goto    JokuPuhuu

        movfw   Counter
        xorwf   SpTimeOutL, W
        btfsc   STATUS, Z       ; jos kukaan ei puhu ? Sekuntiin niin 
        goto    QSOLoppui
        goto    QSOLop1

;--[ kukaan ei ole vhn aikaan sanonut mitn ]--:
;--[ jos kokonaisuudessaan on puhuttu yli 5 vuoroa, anna kutsu lopuksi ]--:
QSOLoppui:
        movfw   Vuorot
        movwf   Temp3
        movlw   0x05            ; yli 5 vuoroa
        subwf   Temp3,1
        btfss   STATUS, C
        goto    MainLoop

        bsf     PORTA, IO_TX    ; lhetin plle
        bcf     PORTA, IO_Mute  ; Mykistys plle
        call    PSekTauko        ; puolen sekunnin tauko

;--[ lhet ID3 ]--:             ; antaa toistimen kutsun
        movlw   0x10
        movwf   Temp3
SendID3
        bcf     STATUS, RP0
        movfw   Temp3
        call    LueEEPROM
        call    CW

        incf    Temp3, F
        movfw   Temp3

        xorlw   0x18
        btfss   STATUS, Z
        goto    SendID3

        call    PSekTauko       ; puolen sekunnin tauko
                
        bcf     PORTA, IO_TX    ; lhetin pois
        bsf     PORTA, IO_Mute  ; Mykistys pois

        movlw   0x3F
        call    LueEEPROM
        incf    EEDATA, F
        call    KirjoitaEEPROM

        movfw   EEDATA
        xorlw   0x00
        btfss   STATUS, Z
        goto    SendID4

        movlw   0x3E
        call    LueEEPROM
        incf    EEDATA, F
        call    KirjoitaEEPROM

SendID4:
        goto    MainLoop        ; odota seuraavaa uhria

;--[ toistin mennyt ympri ]---;
;--[ ilmoita ett toistin menee kiinni (esim. shkt CL)
Ympari:
        movlw   0x18           
        call    LueEEPROM       ; ensimminen sulkukirjain
        call    CW

        movlw   0x19
        call    LueEEPROM       ; toinen sulkukirjain
        call    CW

        call    PSekTauko       ; taukoa
        bcf     PORTA, IO_TX    ; lhetin pois

;--[ nyt odota ett ukon puheenvuoro loppuu ]--;
Ympari1:
        btfsc   PORTB, IO_Sql   ; salpa viel auki?
        goto    Ympari1         ; jos niin, jatka luuppia

        movlw   0x78          
        movwf   IntrCount       ; IntrCount puoleen
        clrf    Counter         ; nollaa laskuri
Ympari2:
        btfsc   PORTB, IO_Sql   ; palasiko salpa takaisin
        goto    Ympari1         ; jatka puheenvuoroa

        movfw   Counter
        xorlw   0x01
        btfss   STATUS, Z
        goto    Ympari2

        bsf     PORTA, IO_TX    ; lhetin plle
        bcf     PORTA, IO_Mute  ; Mykistys plle
        call    PSekTauko       ; taukoa, sitten QSOLopetettu kohtaan
        call    Bongo
        bcf     PORTA, IO_Mute  ; Mykistys plle taas
        call    Bongo           ; tupla Bongo
        call    PSekTauko       ; puolen sekunnin tauko
        bcf     PORTA, IO_TX    ; lhetin pois

        goto    QSOLopetettu

;--[ lhett w rekisteriss olevan merkin CWll ]--:
CW:
        call    CWMerkki
        movwf   CWChar

        xorlw   0xFF            ; kaikki 1?
        btfsc   STATUS, Z
        return                  ; ohita merkki

        movfw   CWChar
        xorlw   0x00            ; kaikki 0?
        btfsc   STATUS, Z
        goto    TyhjaMerkki

        movlw   7
        movwf   Temp2

EtsiNolla:
        rlf     CWChar, F
        btfss   STATUS, C
        goto    NollaLoytyi
        decfsz  Temp2, F
        goto    EtsiNolla

NollaLoytyi:
        rlf     CWChar, F
        btfss   STATUS, C
        call    Viiva             ; jos nolla, ni pll 2 yks. verran
        call    SendUnitOn        ; ni pll 1 yks. verran.
        call    SendUnitOff       ; 1 yks. tauko
        decfsz  Temp2, F
        goto    NollaLoytyi

        call    SendUnitOff       ; pid 2 mittainen tauko
        call    SendUnitOff       
        return
                
Viiva:
        call    SendUnitOn  
        call    SendUnitOn
        return

;--[ lhett yhden unitsin.. Viiva on 3 sellaista ]--:
SendUnitOn      movfw   CWSpeed
                movwf   Temp
SendUnitOn1
                bsf     PORTA, IO_SND   ; nt ulos
                clrw
                call    KeepPause       ; pid taukoa
                movfw   CWPitch
                call    KeepPause       ; pid taukoa

                bcf     PORTA, IO_SND   ; ei nt ulos
                clrw
                call    KeepPause       ; pid taukoa
                movfw   CWPitch
                call    KeepPause       ; pid taukoa

                decfsz  Temp, F         ; laske Temppi kunnes nolla
                goto    SendUnitOn1
                return

;--[ pit taukoa yhden unitsin.. Viiva on 3 sellaista ]--:
SendUnitOff     movfw   CWSpeed
                movwf   Temp
SendUnitOff1
                bcf     PORTA, IO_SND   ; EI nt ulos
                clrw
                call    KeepPause       ; pid taukoa
                movfw   CWPitch
                call    KeepPause       ; pid taukoa

                bcf     PORTA, IO_SND   ; ei nt ulos
                clrw
                call    KeepPause       ; pid taukoa
                movfw   CWPitch
                call    KeepPause       ; pid taukoa

                decfsz  Temp, F         ; laske Temppi kunnes nolla
                goto    SendUnitOff1
                return

TyhjaMerkki:
                call    SendUnitOff
                call    SendUnitOff
                call    SendUnitOff
                call    SendUnitOff
                call    SendUnitOff
                call    SendUnitOff
                call    SendUnitOff
                return        

;--[ jonkun KeepPause  rutiini ]--:
KeepPause       addlw   0x01                ;adds one to reg 1
                btfss   STATUS, Z           ;if z flag is on, skip next
                goto    KeepPause           ;z is off? ok lets inc W until
                return                      ;it goes over 255

PSekTauko:
                movlw   0x78
                movwf   IntrCount       ; IntrCount puoleen
                clrf    Counter         ; nollaa laskuri
PSekLoop:
                movfw   Counter
                xorlw   0x01
                btfss   STATUS, Z
                goto    PSekLoop
                return

Bongo:
                bcf     PORTA, IO_Mute  ; Mykistys plle
                movlw   0x16            ; <- ekan nen pituus
                movwf   Temp
SendBongo1                              ;-korkea ni
                bsf     PORTA, IO_SND   ; nt ulos
                clrw
                call    KeepPause       ; pid taukoa
                movlw   0xFF            ; <- ekan nen taajuus
                call    KeepPause       ; pid taukoa

                bcf     PORTA, IO_SND   ; ei nt ulos
                clrw
                call    KeepPause       ; pid taukoa
                movlw   0xFF            ; <- ekan nen taajuus
                call    KeepPause       ; pid taukoa

                decfsz  Temp, F         ; laske Temppi kunnes nolla
                goto    SendBongo1

                movlw   0x16            ; <- toisen nen pituus
                movwf   Temp
SendBongo2                              ;-ja pern matalampi ni
                bsf     PORTA, IO_SND   ; nt ulos
                clrw
                call    KeepPause       ; pid taukoa
                movlw   0x7F            ; <- toisen nen taajuus
                call    KeepPause       ; pid taukoa

                bcf     PORTA, IO_SND   ; ei nt ulos
                clrw
                call    KeepPause       ; pid taukoa
                movlw   0x7F            ; <- toisen nen taajuus
                call    KeepPause       ; pid taukoa

                decfsz  Temp, F         ; laske Temppi kunnes nolla
                goto    SendBongo2

                bsf     PORTA, IO_Mute  ; Mykistys pois
                return

LueEEPROM:
                movwf   EEADR
                bsf     STATUS, RP0
                bsf     EECON1^80H, RD
                bcf     STATUS, RP0
                movf    EEDATA, W
                return

KirjoitaEEPROM:
                bsf     STATUS, RP0   ; Bank 1
                bcf     INTCON, GIE   ; Disable INTs.
                bsf     EECON1^80H, WREN ; Enable Write
                movlw   0x55 
                movwf   EECON2^80H    ; Write 55h
                movlw   0xAA
                movwf   EECON2^80H    ; Write AAh
                bsf     EECON1^80H,WR ; Set WR bit
                                      ; begin write
EELoop          btfsc   EECON1^80H, WR ; odota ett tallentuu
                goto    EELoop
                bcf     EECON1^80H, WREN
                bcf     EECON1^80H, EEIF
                bsf     INTCON, GIE   ; Enable INTs.
                bcf     STATUS, RP0   ; Bank 0
                return

        org     0x03E8
        data    'V','e','r','.','1','.','1','i'
        data    '2','6','-','0','7','-','0','2'
        data    '*','O','H','3','H','R','K','*'

;--[ koodin loppu ]--:
        end
